
### Thermostability virus 24h infection rep good

setwd("N://Alfonso_Gomez//1 - Experimental Procedures//191108_Thermo_2//CellProfAnalys")

library("tidyr")

Plate20 <- read.csv2("191108_Thermostability_24h_inf_rep_Nucleus.csv", header = T, sep = ",")

Plate20 <- as.data.frame(Plate20)

library("stringr")

add_my_numbers <- function(data){
  a <- str_split_fixed(data$Metadata_Well,"",n = 2)
  L <- as.character(a[,1])
  N <- as.numeric(a[,2])
  data <- cbind(data, "Letter_Well"=L,"Number_Well"=N)
  return(data)
}

New_plate20 <- add_my_numbers(Plate20)

New_plate20$Letter_Well <- gsub("A","1", New_plate20$Letter_Well)
New_plate20$Letter_Well <- gsub("B","2", New_plate20$Letter_Well)
New_plate20$Letter_Well <- gsub("C","3", New_plate20$Letter_Well)
New_plate20$Letter_Well <- gsub("D","4", New_plate20$Letter_Well)
New_plate20$Letter_Well <- gsub("E","5", New_plate20$Letter_Well)
New_plate20$Letter_Well <- gsub("F","6", New_plate20$Letter_Well)
New_plate20$Letter_Well <- gsub("G","7", New_plate20$Letter_Well)
New_plate20$Letter_Well <- gsub("H","8", New_plate20$Letter_Well)

New_plate20$Letter_Well <- as.numeric(New_plate20$Letter_Well)

New_plate20$Letter_Well[1700]

######
## Now its time to count the cells in each well (Por, Neg,...)
######
## First transform the columns of the signals into numbers (not characters)

as.numeric.factor <- function(x){
  as.numeric(levels(x))[x]
}

New_plate20$Intensity_MeanIntensity_pVI <- as.numeric.factor(New_plate20$Intensity_MeanIntensity_pVI)

library("ggplot2")

ggplot()+
  geom_point(data = New_plate20,aes(x = Number_Well,y = Intensity_MeanIntensity_pVI), size=0.5)+
  xlab("well")+
  ylab("pVI intensity")

### cALCULATE YOUR BACKGROUND FOR THE SIGNALS

back20 <- subset(New_plate20, New_plate20$Letter_Well < 3)

bpVI20 <- back20[which(back20$Intensity_MeanIntensity_pVI >= 0.0215),]

## then proceed with the great function
output <- matrix(nrow = 96, ncol = 8)


counting <- function(workp){
  Li <- workp$Letter_Well[1]
  Lf <- workp$Letter_Well[dim(workp)[1]]
  Ni <- workp$Number_Well[1]
  Nf <- workp$Number_Well[dim(workp)[1]]
  for (i in Li:Lf) {
    for (k in Ni:Nf) {
      p <- subset(workp, (workp$Letter_Well == i) & (workp$Number_Well == k))
      ce <- dim(p)[1]
      if (ce < 50) {
        ce1 <- 50
        pVI <- dim(p[p$Intensity_MeanIntensity_pVI >= 0.0215,])[1]
        Neg <- Neg <- dim(p[p$Intensity_MeanIntensity_pVI < 0.0215,])[1]
        PerPos <- ((pVI+ce1-ce)/ce1)*100
        PerNeg <- 100 - PerPos
        update <- c(i,i, k, ce, pVI, PerPos, Neg, PerNeg)
        output[((i-2)*6)+(k-1),] <- update
      } else {
        pVI <- dim(p[p$Intensity_MeanIntensity_pVI >= 0.0215,])[1]
        Neg <- dim(p[p$Intensity_MeanIntensity_pVI < 0.0215,])[1]
        PerPos <- (pVI/ce)*100
        PerNeg <- 100 - (pVI/ce)*100
        update <- c(i,i, k, ce, pVI, PerPos, Neg, PerNeg)
        output[((i-1)*12)+(k),] <- update
      }
    }
  }
  return(output)
}



counting2 <- function(workp){
  Li <- workp$Letter_Well[1]
  Lf <- workp$Letter_Well[dim(workp)[1]]
  Ni <- workp$Number_Well[1]
  Nf <- workp$Number_Well[dim(workp)[1]]
  for (i in Li:Lf) {
    for (k in Ni:Nf) {
      p <- subset(workp, (workp$Letter_Well == i) & (workp$Number_Well == k))
      ce <- dim(p)[1]
      pVI <- dim(p[p$Intensity_MeanIntensity_pVI >= 0.015,])[1]
      Neg <- dim(p[p$Intensity_MeanIntensity_pVI < 0.015,])[1]
      PerPos <- (pVI/ce)*100
      PerNeg <- 100 - (pVI/ce)*100
      update <- c(i,i, k, ce, pVI, PerPos, Neg, PerNeg)
      output[((k-1)*6)+(i-1),] <- update
    }
  }
  return(output)
}

Titring20 <- counting(New_plate20)
colnames(Titring20) <- c("Letter_Well","Letter_Well_cod", "Number_Well", "Cells_in_Well","pVIpos","PercentPos", "Neg","PercentNeg")
Titring20 <- as.data.frame(Titring20)

Titring20$Letter_Well_cod <- gsub("1","A", Titring20$Letter_Well_cod)
Titring20$Letter_Well_cod <- gsub("2","B", Titring20$Letter_Well_cod)
Titring20$Letter_Well_cod <- gsub("3","C", Titring20$Letter_Well_cod)
Titring20$Letter_Well_cod <- gsub("4","D", Titring20$Letter_Well_cod)
Titring20$Letter_Well_cod <- gsub("5","E", Titring20$Letter_Well_cod)
Titring20$Letter_Well_cod <- gsub("6","F", Titring20$Letter_Well_cod)
Titring20$Letter_Well_cod <- gsub("7","G", Titring20$Letter_Well_cod)
Titring20$Letter_Well_cod <- gsub("8","H", Titring20$Letter_Well_cod)

plot(c(1:96), Titring20$PercentPos)

write.csv2(Titring20, file = "191108_Thermostability_inf_24h_rep.csv")

##Separate infection times
##Make two different subgroups with 2-4 and 5-7

wt <- subset(Titring20, Titring20$Letter_Well > 2 & Titring20$Letter_Well < 5)

VKR <- subset(Titring20, Titring20$Letter_Well > 4 & Titring20$Letter_Well < 7)

dV <- subset(Titring20, Titring20$Letter_Well > 6)


calc_my_meansd <- function(titr){
  ni <- titr$Number_Well[1]
  nf <- titr$Number_Well[dim(titr)[1]]
  output <- matrix(nrow = (nf-ni+1),ncol = 5)
  for (i in ni:nf) {
    if (i==1) {
      col <- i
      dil <- 0
      logdil <- log10(dil)
      inf <- mean(titr$PercentPos[titr$Number_Well == i])
      sd <- sd(titr$PercentPos[titr$Number_Well == i])
      update <- c(col, dil, logdil, inf, sd)
      output[i,] <- update
    }
    else{
      col <- i
      dil <- 1/(100*2^(i-2))
      logdil <- log10(dil)
      inf <- mean(titr$PercentPos[titr$Number_Well == i])
      sd <- sd(titr$PercentPos[titr$Number_Well == i])
      update <- c(col, dil, logdil, inf, sd)
      output[i,] <- update
    }
  }
  return(output)
}

meanAwt <- calc_my_meansd(wt)
colnames(meanAwt) <- c("Column", "Dilution","log", "Infpercentmean", "SD")

meanVKR <- calc_my_meansd(VKR)
colnames(meanVKR) <- c("Column", "Dilution","log", "Infpercentmean", "SD")

meandV <- calc_my_meansd(dV)
colnames(meandV) <- c("Column", "Dilution","log", "Infpercentmean", "SD")

##Plot them independently

library("ggplot2")

meanA549 <- as.data.frame(meanA549)
meanHeLa <- as.data.frame(meanHeLa)

ggplot(meanA549,aes(x = log,y = Infpercentmean)) + geom_point(size=2) + 
  geom_errorbar(aes(ymin=Infpercentmean-SD, ymax=Infpercentmean+SD), width=0.1) +
  ggtitle("A549_20hpi") +
  ylab("Percentage of infection") + 
  ylim(0,80) +
  xlab("Log10(dilution)")


ggplot(meanHeLa,aes(x = log,y = Infpercentmean)) + geom_point(size=2) +
  geom_errorbar(aes(ymin=Infpercentmean-SD, ymax=Infpercentmean+SD), width=0.1) +
  ggtitle("HeLa_20hpi") +
  ylab("Percentage of infection") + 
  ylim(0,80) +
  xlab("Log10(dilution)")

ggplot() + 
  geom_point(data = meanA549[2:12,], aes(x = log, y = Infpercentmean), colour = "red",size=2 ) + 
  geom_errorbar(data= meanA549[2:12,], aes(x = log, ymin= Infpercentmean - SD, ymax= Infpercentmean + SD), width=0.1) +
  geom_point(data = meanHeLa[2:12,], aes(x = log, y = Infpercentmean), colour = "orange",size=2 ) + 
  geom_errorbar(data= meanHeLa[2:12,], aes(x = log, ymin= Infpercentmean - SD, ymax= Infpercentmean + SD), width=0.1) +
  ylab("Percentage of infection") + 
  xlab("Log10(dilution)")
